"""
The interesting part starts at class MainButtons below :)
"""
from __future__ import print_function

try:
    import poser
except ImportError:
    raise RuntimeError("Must run in Poser.")
import os
import sys
import wx

THISPATH = os.path.dirname(os.path.abspath(sys.argv[0]))
if not os.path.exists(os.path.join(THISPATH, "__init__.py")):
    # this file must exist to be able to make includes
    with open(os.path.join(THISPATH, "__init__.py"), "w"):
        pass

if THISPATH not in sys.path:
    sys.path.append(THISPATH)

import PoserLibs.PoserMenu

# this import is used to set some variables.
PoserLibs.PoserMenu.BUTTON_KEYWORD = "BUTTON"
PoserLibs.PoserMenu.TEMPDIR = poser.TempLocation()

# Standard import.
from PoserLibs.PoserMenu import \
    TEMPDIR, \
    TITLE, \
    BUTTON_KEYWORD, \
    restore_buttons, \
    MenuClass

print("-" * 50 + "\nTemporary script are stored in '%s'." % TEMPDIR)
print("Button Keyword is: '%s'" % BUTTON_KEYWORD)
print("Script name is: '%s'" % TITLE)
print("(Feel free to change anything above to your needs.)\n" + "_" * 50)
print("\nMake sure the 'Python Buttons' are displayed in Poser: Main Menu->Window->Python Scripts")

# A global variable to show transfer of data
# (see below where buttons are defined).
test1 = "This is global variable 'test1'"

# Required to find this script for the back button.
THISFILE = os.path.abspath(__file__)
print("Script Base location:", THISFILE)


class MainButtons(MenuClass):

    def setup(self):
        """
        setup() - will be called before buttons are displayed.
        Use it to set up what ever you need.
        """
        return

    # Remember: You may call the button-methods via script in
    # addition to click it.
    # Don't forget to define '*args', because the buttons are
    # maybe called with parameters.

    def BUTTON_Number_1(self, *args):
        """
        Method name behind keyword ('BUTTON') doesn't matter. Except
        for 'next' and 'back' (see below).

        Three args are declared below.
        'test1' is previously declared in the script as a global variable.

        All other args results in whatever they contain if this button is
        clicked, or, in case they are not defined, just their variable-name.
        '$name' is a special variable and results in the name of the
        actual method ("BUTTON_Number_1" in this case).

        You may leave comments in the description part. Anything not enclosed
        in ':' is ignored. Also anything after '#' in lines with keywords.

        :<keyword>: <content> # <Description>

        The content-part may have keywords also. These keywords are
        prefixed with '$'.
        $name = Name of method.
        $index = Button indexnumber.


        ===================== the interesting part ========================
        :nr: 1 # Button number.
        :title: First Button from Main # Button-Title.
        :args: test1, test2, $name
        """
        print("%s pressed. Button index=1" % args[-1])
        print("'test1' is a global variable.")
        print("This args I got:", args)

    def BUTTONnext(self, *args):
        """
        'next' and 'back' in method-name are keywords too.
        def BUTTONnext() and def BUTTONback() are automatically set to the last
        two buttons if no button indexnumber is given.
        ATTENTION: This may overwrite previously defined buttons (9 or 10)!

        ===================== the interesting part ========================
        :title: Second Menu >>>
        """
        self.add(ButtonMenu_1)

    def BUTTONback(self, *args):
        """
        Here we switch back to original script menu, but we leave
        an entry to call this script again (assumed a free slot at index 9).

        We can not use 'self.back()', because this menu is the first one
        in the list with no previous menu defined. So we must call the original
        ScriptButton-script via restore_buttons() from imported 'PoserMenu.py'.

        ===================== the interesting part ========================
        :title: <<< Back to Original
        (Button index is automatically set)
        """
        restore_buttons()
        poser.DefineScriptButton(9, THISFILE, TITLE)


# Now the second button menu, but without comments.

class ButtonMenu_1(MenuClass):
    def BUTTON_second_test(self, *args):
        """
        :Nr: 1
        :Title: 1. Button from Second Menu
        """
        print("This is ButtonMenu_1 button nr. 1")

    def BUTTON_second_anotherone(self, *args):
        """
        :Nr: 2
        :Title: 2. Button from Second Menu
        :args: $name
        """
        print("This is method '%s' from class '%s'" %
              (args[0], self.__class__.__name__))

    def BUTTONnext(self, *args):
        """
        :title: Third Menu >>>
        """
        self.add(ButtonMenu_2)

    def BUTTONback(self, *args):
        """
        :title: <<< Back to First Menu
        """
        self.back()


class ButtonMenu_2(MenuClass):
    def BUTTON_third_test(self, *args):
        """
        :Nr: 1
        :Title: Third menu #1
        :args: $index
        """
        print("This is ButtonMenu_2 button nr.", args[0])

    def BUTTON_third_without_index(self, *args):
        """
        The first free slot will be assigned to this button.
        :Title: Without index
        :args: $index
        """
        print("This is ButtonMenu_2 button nr.", args)

    def BUTTON_Next(self, *args):
        """
        No title, no number.
        """
        self.add(ButtonMenu_3)

    def BUTTONback(self, *args):
        """
        :title: <<< Back to Second Menu
        :nr: 5 # Here we overwrite the automatic index generation.
        """
        self.back()


class ButtonMenu_3(MenuClass):
    def setup(self):
        self.clearButtons()
        self.displayButtons()

    def BUTTON_1_fromMethodName(self, *args):
        """
        Button-nr is 1, defined in method-name (part after first "_").
        Title of this button is "fromMethodName", defined in method-name (part after last "_")
        :args: $index
        """
        print("Button nr. is %s. Button-nr is defined in method-name." % args[0])

    def BUTTON_withoutNumber(self, *args):
        """
        :args: $index
        """
        print("Button-nr (%s) automatically generated.Button-name defined in method-name." % args[0])

    def BUTTON_10_GoBack(self, *args):
        """
        Index nr and title defined in method-name
        """
        self.back()


# Call the first Button Menu to start the show.
MainButtons()
